/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SYNTH_FILTER_H_
#define __GDAM_SYNTH_FILTER_H_

#include "gdamsynthsource.h"

typedef struct _GdamSynthFilter GdamSynthFilter;
typedef struct _GdamSynthFilterClass GdamSynthFilterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_synth_filter_get_type();
#define GDAM_TYPE_SYNTH_FILTER			(gdam_synth_filter_get_type ())
#define GDAM_SYNTH_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SYNTH_FILTER, GdamSynthFilter))
#define GDAM_SYNTH_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SYNTH_FILTER, GdamSynthFilterClass))
#define GDAM_IS_SYNTH_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SYNTH_FILTER))
#define GDAM_IS_SYNTH_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SYNTH_FILTER))

struct _GdamSynthFilterClass {
	GdamSynthSourceClass		synth_filter_class;
};
struct _GdamSynthFilter {
	GdamSynthSource			synth_filter;
	GdamSynthSource*		filtered;
};

void gdam_synth_filter_set_filtered(GdamSynthFilter*   filter,
                                    GdamSynthSource*   filtered);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
